import numpy as np

class Grid:
    def __init__(self, x):
        self.x = x
        self.dx = x[1] - x[0]
        self.n = len(x)

    def zeros(self, shape=(), dtype=float):
        return np.zeros((self.n,) + shape, dtype=dtype)

    def int(self, a_x, axis=0):
        return a_x.sum(axis=axis) * self.dx

    def norm2(self, psi_x, axis=0):
        return self.int(psi_x**2, axis=axis)

    def norm(self, psi_x, axis=0):
        return np.sqrt(self.norm2(psi_x, axis=axis))

    def normalize(self, psi_x, axis=0):
        raise NotImplementedError
        shapeoffset = (np.array(psi_x.shape) + axis) % len(psi_x.shape)
        psi_ay = psi_x.transpose(*shapeoffset)
        psi_ay /= self.norm(psi_ay, axis=0)[None, ...]
    #    norms = self.norm(psi_x, axis=axis)
    #    print psi_x.shape
    #    print norms.shape
    #    sdjf
    #    shape = [1] * len(psi_x.shape)
    #    shape[axis] = len(norms)
    #    print tuple(shape)
    #    psi_x /= norms.reshape(tuple(shape))


class RadialGrid(Grid):
    def __init__(self, x):
        if (x <= 0).any():
            raise ValueError('Negative radial coordinates')
        Grid.__init__(self, x)

    #def norm(self, rpsi_x, axis=0):
    #    assert axis == 0
    #    return Grid.norm(self, rpsi_x / self.x[:, None], axis=axis)
