import numpy as np
from pydft.operator import get_kinetic, get_derivative

x = np.linspace(-6, 6, 301)
dx = x[1] - x[0]
n = np.exp(-x**2)

import pylab as pl

fig = pl.figure()
ax1 = fig.add_subplot(211)
ax2 = fig.add_subplot(212)

for order in range(1, 4):
    D = get_derivative(x, order=order)
    ax1.plot(x, np.dot(D, n))
ax1.plot(x, np.gradient(n, dx), ls='--')

D3 = get_derivative(x, order=3)
T3 = get_kinetic(x, order=3)

T3_2 = -0.5 * np.dot(D3, D3)

ax2.plot(x, np.dot(T3, n), ls='--')
ax2.plot(x, np.dot(T3_2, n))

pl.show()
